// This just works with one variable from the Game Dash.
int Speed ;
int SpeedGameDash = 0;
int MaxSpeed = 0;
int PotReading = 0;
int bufferArray[4];

void setup(){
  
  pinMode(11,OUTPUT);
    
  Serial.begin(9600);
}

void loop(){ 
  //****************************** READ DATA FROM SERIAL ******************************
  
    ReadData();
    CheckPot();
    CalcPWM();
}
 

void ReadData(){
  
  if (Serial.available() == 4)  {    //if 4 bits available in the Serial buffer...
        
        int i;
        for (i=0; i<4; i=i+1) {       // read and label each byte.
         bufferArray[i] = Serial.read();
         }
        
         if (bufferArray[0]  == 'S'){
           SpeedGameDash = ((bufferArray[1]-48)*100) + ((bufferArray[2]-48)*10) + // Take values 1-3.
                               ((bufferArray[3]-48)*1);  
           //Serial.print("You have set the Speed to a Value of:");     
           //Serial.println(SpeedGameDash);
       }
  }
}
void CheckPot(){
    PotReading = analogRead(0);
    MaxSpeed = PotReading;
    
    
 }


void CalcPWM() {
    
    if (SpeedGameDash > 0){
    int oldSpeed = Speed;
    Speed = map(SpeedGameDash, 0 ,MaxSpeed, 0 , 255);
    if (oldSpeed != Speed){
    //Serial.print("Fan Speed set to :");
    if (Speed < 0 ){Speed = 0;}
    if (Speed > 255){Speed = 255;}
    //Serial.println(Speed);
    analogWrite(11,Speed);
  }
  }
}
